public class TreeNode
{
  private Object value;
  private TreeNode left;
  private TreeNode right;

  private TreeNode parent;

  // Constructors:

  public TreeNode(Object initValue)
  {
    value = initValue;
    left = null;
    right = null;

    parent = null;
  }

  public TreeNode(Object initValue, TreeNode initLeft, TreeNode initRight)
  {
    value = initValue;
    left = initLeft;
    right = initRight;

    parent = null;
  }


  // Methods:

  public Object getValue() { return value; }
  public TreeNode getLeft() { return left; }
  public TreeNode getRight() { return right; }
  public void setValue(Object theNewValue) { value = theNewValue; }
  public void setLeft(TreeNode theNewLeft) { left = theNewLeft; }
  public void setRight(TreeNode theNewRight) { right = theNewRight; }

  public TreeNode getParent() { return parent; }
  public void setParent(TreeNode p) { parent = p; }
}
